/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: core_support.S 2317 2012-02-23 09:57:35Z ertl-honda $
 */

/*
 *        ¸⥸塼 ֥ARMѡ
 */
#define TOPPERS_MACRO_ONLY
#define TOPPERS_ASM_MACRO
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */

#include "kernel_impl.h"
#include "offset.h"
#include "target_asm.inc"

/*
 * 㳰٥
 */
    ASECTION(vector)
    AGLOBAL(vector_table)
ALABEL(vector_table)
    ldr pc, reset_vector       /* ꥻå             */
    ldr pc, undef_vector       /* ̤̿           */
    ldr pc, swi_vector         /* եȥ   */
    ldr pc, prefech_vector     /* ץեåܡ */
    ldr pc, data_abort_vector  /* ǡܡ       */
    ldr pc, reset_vector
    ldr pc, irq_vector         /* IRQ                  */
    ldr pc, fiq_vector         /* FIQ                  */

/*
 *  㳰٥̿ᤫ黲Ȥ
 *  襢ɥ쥹
 */
    AGLOBAL(vector_ref_tbl)
ALABEL(vector_ref_tbl)
ALABEL(reset_vector)
    ALONG  start
ALABEL(undef_vector)
    ALONG  undef_handler
ALABEL(swi_vector)
    ALONG  swi_handler
ALABEL(prefech_vector)
    ALONG  prefetch_handler
ALABEL(data_abort_vector)
    ALONG  data_abort_handler
ALABEL(irq_vector)
    ALONG  irq_handler
ALABEL(fiq_vector)
    ALONG  fiq_handler

/*
 *  ǥѥå
 *
 */
    ATEXT
    AALIGN(2)
    AGLOBAL(dispatch)
ALABEL(dispatch)
    /*
     *  Υ롼ϡƥȡCPUå֡ǥѥå
     *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
     *  롥
     */
    stmfd sp!, {r4 - r11,lr}           /* 쥸¸ */
    ldr   r0, =p_runtsk                /* p_runtskɤ߹ */
    ldr   r1, [r0]
    str   sp, [r1,#TCB_sp]             /* å¸ */
    adr   r2, dispatch_r
    str   r2, [r1,#TCB_pc]             /* ¹ԺƳϤ¸ */
    b     dispatcher

ALABEL(dispatch_r)
    ldmfd sp!,{r4 - r11,lr}     /* 쥸 */
    /*
     * 㳰롼εư
     * dispatcherƤӽФ뤿ᡤTCBΥɥ쥹r1äƤ
     */
    ldrb  r0,[r1,#TCB_enatex]
    tst   r0,#TCB_enatex_mask
    beq   dispatch_r_1          /* enatex  false ʤ꥿ */
    ldr   r0,[r1,#TCB_texptn]   /* texptn 0ʤ꥿ */
    tst   r0,r0                 
    beq   dispatch_r_1          
    ldr   r1, =ipmflg           /* ipmflgfalseǤХ꥿ */
    ldr   r0, [r1]
    tst   r0,r0
    bne   call_texrtn           /* 㳰롼θƤӽФ */
ALABEL(dispatch_r_1)
    bx    lr


/*
 *  ǥѥåưϡcpu_support.S
 */
    AGLOBAL(start_dispatch)
ALABEL(start_dispatch)
    /*
     *  Υ롼ϡͥ뵯ưˡ٤Ƥγߤػߤ
     * ʳߥå֤ƱˤǸƤӽФ롥ޤߥ⡼ɡ
     *  ƥȤƱˤǸƤӽФ뤳ȤꤷƤ롥
     *
     *  dispatcherϡCPUå֡ʥǥΡ˳ͥ٥ޥ
     *  ֡㳰ʳ/CPU㳰ˤΥͥȲ0ǸƤӽФ     
     *  target_initializeǤϡʥǥΡ˳ͥ٥ޥ
     *  ȤͥγߤǤFIQĤ뤳Ȥǡ
     *  CPUå֡ʥǥΡ˳ͥ٥ޥ֤ˤʤ롥
     *  ޤinitialize_taskdisdspfalse˽Ƥ뤿ᡤǥ
     *  ѥåľ֤ˤʤäƤ롥
     *  
     */    
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET) /* CPUå֤ */
    ldr   r2, =excpt_nest_count            /* 㳰ʳ/CPU㳰ˤΥͥȲ */
    mov   r0, #0                           /* 0                              */
    str   r0, [r2]
    b     dispatcher_0

/*
 *  ߤΥƥȤΤƤƥǥѥå
 */
    AGLOBAL(exit_and_dispatch)
ALABEL(exit_and_dispatch)
    /* ǥѥåΡdispatcherˤ */    

/*
 *  ǥѥå
 */
ALABEL(dispatcher)
    /*
     *  Υ롼ϡƥȡCPUå֡ǥѥå
     *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
     *  롥¹ԺƳϤؤ⤳ξ֤Τޤʬ롥
     *
     *  ʤѡХ⡼ɡIRQػߡdisdspfalsedspflg
     *  trueȤʤäƤ롥¹ԺƳϤؤ⤳ξ֤Τޤʬ롥
     */
#ifdef LOG_DSP_ENTER
    ldr   r1, =p_runtsk     /* p_runtskѥ᡼ */
    ldr   r0, [r1]        
    bl    log_dsp_enter
#endif /* LOG_DSP_ENTER */
ALABEL(dispatcher_0)
    ldr   r0, =p_schedtsk   /* p_schedtskp_runtsk */
    ldr   r1, [r0]
    ldr   r2, =p_runtsk   
    str   r1, [r2]        
    cmp   r1, #0            /* p_runtskNULLʤdispatcher_1 */
    beq   dispatcher_1             
    ldr   sp, [r1,#TCB_sp]  /* å */
#ifdef LOG_DSP_LEAVE
    mov   r0, r1            /* p_runtskѥ᡼ */
    mov   r4, r1            /* r1ϥå쥸ʤΤ¸ */
    bl    log_dsp_leave
    mov   r1, r4
#endif /* LOG_DSP_LEAVE */
    ldr   r4, [r1,#TCB_pc]  /* ¹ԺƳϤ   */    
    bx    r4
ALABEL(dispatcher_1)
    /*
     * CPUå֤βȡ󥿥ƥȼ¹Ծ֤ؤ
     * 򤹤
     */
    ldr   r0, =_kernel_istk            /* 󥿥ƥȤΥå */
    ldr   sp, [r0]    
    ldr   r1, =_kernel_istksz
    ldr   r3, [r1]
    add   sp, sp, r3
    mov   r4, #0
    mov   r5, #1
    ldr   r6, =reqflg                  /* r6 <- reqflg */
    ldr   r7, =excpt_nest_count        /* r7 <-excpt_nest_count */
ALABEL(dispatcher_2)
    /*
     *  ߤĤ󥿥ƥȼ¹Ծ֤ȤߤԤġ
     *
     *  󥿥ƥȼ¹Ծ֤ڤ괹Τϡȯ
     *  ߽ˤɤΥåȤȤβȡ
     *  ϥɥǤΥǥѥåɻߤȤ2Ĥΰ̣롥
     *
     *  ץåԤ˰ܹԤȡߵĤȤϡԲ
     *  ʬ˹Ԥʤɬפ롥
     *  Բʬ˹Ԥʤʤ硤ߤĤľ˳
     *  ߤꡤǥ¹Բǽ֤ˤʤȡ¹Ԥ٤
     *  ˤ⤫餺ץåԤˤʤäƤޤ
     *
     *  Ԥδ֤ϡp_runtskNULLʡ0ˤꤷʤФʤ
     *  Τ褦ꤷʤȡߥϥɥ餫iget_tidƤӽ
     *  ݤưͤ˹פʤʤ롥
     *
     *  åȤˤäƤϡϥ⡼˰ܹԤ뤿ᡤɸˡ
     *  ۤʤ礬ɬפʾ礬롥
     *  Τ褦ʥåȤǤϡåȰ¸ˤơTOPPERS_CUSTOM_IDLE
     *  ֥ޥȤơtoppers_asm_custom_idle Ѱ
     *  Ф褤
     *
     *  ʤtoppers_asm_custom_idle εҤˤäƤϡΥ쥸
     *  toppers_asm_custom_idleǻѤ뤿ᡤ
     *  toppers_asm_custom_idle ǻѤϡ¸뤳ȡ
     *  Υ쥸 Calee saved 쥸Ǥ뤿ᡤ 
     *  toppers_asm_custom_idle ȤƴؿƤӽФ򤷤ϡƤӽФ
     *  ؿǼưŪ¸뤿ᡤ֥٥Ǥ¸ɬ
     *  פʤ
     *
     *  쥸 : 
     *   r4      : '0'
     *   r5      : '1'
     *   r6      : reqflgΥɥ쥹
     *   r7      : excpt_nest_countΥɥ쥹
     *   sp      : 󥿥ƥѤΥåƬɥ쥹
     */
    str   r5, [r7]                          /* excpt_nest_count = 1 */

#ifdef TOPPERS_CUSTOM_IDLE
    toppers_asm_custom_idle
#else /* !TOPPERS_CUSTOM_IDLE */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_ALWAYS_SET) /* ߵ(ѡХ⡼) */
    nop
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET) /* CPUå(ѡХ⡼) */
#endif /* TOPPERS_CUSTOM_IDLE */

    ldr   r8, [r6]        /* reqflgfalseʤdispatcher_2 */
    cmp   r8, #0          
    beq   dispatcher_2                 
    str   r4, [r6]        /* reqflgfalse */
    str   r4, [r7]        /* excpt_nest_count = 0 */
    b     dispatcher_0


/*
 *  ͥνλθƽФ
 *
 *  ⡼ɤȥå󥿥ƥѤڤؤ
 */
    AGLOBAL(call_exit_kernel)
ALABEL(call_exit_kernel)
    msr  cpsr_cxsf, #(CPSR_SVC AOR CPSR_ALWAYS_SET AOR CPSR_IRQ_BIT AOR CPSR_FIQ_BIT) 
    ldr  r0, =_kernel_istkpt       /* 󥿥ƥȤΥå */
    ldr  sp, [r0]
    b     exit_kernel


/*
 *  ϻ
 *
 *  dispatcherƤӽФ뤿ᡤTCBΥɥ쥹r1äƤ
 */
    ATEXT
    AGLOBAL(start_r)
ALABEL(start_r)
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_ALWAYS_SET) /* CPUå֤ */
    ldr   lr, =ext_tsk                      /*  */
    ldr   r2, [r1, #TCB_p_tinib]            /* p_runtsk->p_tinibr2  */
    ldr   r0, [r2, #TINIB_exinf]            /* exinf쥸r0  */
    ldr   r1, [r2, #TINIB_task]             /* ưϤ˥ */
    bx    r1 


/*
 *  ߥϥɥ/CPU㳰ϥɥи
 *
 *  ret_intϡߥϥɥ餫äľ˼¹Ԥ롼ǡ
 *  ߥϥɥ齪λ塤åȰ¸ν¹Ԥ塤
 *  ͥγߤػߡåΥåˤ
 *  ֤ǸƤӽФ롥
 */
    ATEXT
    AGLOBAL(ret_int)
    AGLOBAL(ret_exc)
ALABEL(ret_int)
ALABEL(ret_exc)
    /*
     *  㳰ߤΥͥȥȡexcpt_nest_count)Υǥ
     */        
    ldr   r0, =excpt_nest_count   /* r0 <-excpt_nest_count */
    ldr   r1, [r0]
    sub   r2, r1, #1
    str   r2, [r0]
    cmp   r2, #0                  /* 褬󥿥ƥȤʤ */
    bne   ret_int_1               /* ˥꥿                   */

    /*
     *  reqflgå˳ߤػߤΤϡreqflgå
     *  ľ˳ߥϥɥ餬ư졤ǥǥѥå׵
     *  줿ˡ˥ǥѥåʤȤ꤬뤿
     *  Ǥ롥
     */
    ldr   r0, =reqflg
    ldr   r1, [r0]
    cmp   r1, #0                  /* reqflgtrueǤret_int_2 */
    bne   ret_int_2

ALABEL(ret_int_1)
    /*
     *  ߽Υ꥿ˤꡤCPUå֤˰ܹԤʤ
     *  ʤʤ    
     *  ARMǤϡCPSRIRQӥåȤCPUå֤Ȥ뤿ᡤñ˥꥿
     *  Ф褤
     */
#if (__TARGET_ARCH_ARM == 4) || (__TARGET_ARCH_ARM == 5)
    ldmfd sp!,{r1}              /* CPSR */
    msr   spsr_cxsf, r1         /* cpsrspsr */
    ldmfd sp!,{r0-r3,ip,lr,pc}^ /* ƥȤ^դʤΤǡcpsr <- spsr */
#else /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */
    ldmfd sp!,{r0-r3,ip,lr}
    rfeia sp!
#endif /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */

    
ALABEL(ret_int_2)
ALABEL(ret_int_3)
    /*
     *  ؤϡCPU㳰ϥɥνиʬƤ롥
     *
     *  Ǥϡ褬Ǥꡤåϡåξ
     *  ˥å쥸Τߤ¸줿֤ˤʤäƤ롥ޤ
     *  ץåϡѡХ⡼ɡͥγߤػ
     *  ֤ȤʤäƤ롥
     */    
    ldr   r0, =reqflg    /* reqflgfalse */
    mov   r1, #0
    str   r1, [r0]

    /*
     *  CPUå֤˰ܹԤͥ٥ޥ߽ͤ
     *  ꤹ롥
     *
     *  λCPUå֤ȤΤϡdispatcherʬȡ
     *  call_texrtnƤӽФˡCPUå֤ˤʤäƤɬפ
     *  Ǥ롥
     *
     *  CPUå֤˴ؤƤϡARMǤϡCPSRIRQӥåȤCPUå
     *  ֤ɽ뤿ᡤǤϡä˲Ԥʤ
     *
     *  ͥ٥ޥ˴ؤƤϡåۤʤ뤿ᡤ
     *  ߥϥɥ齪λľ˥åȰ¸ǳ߽ͤ
     *  ꤹ롥
     */
    
    /*
     *  dspflgfalseǤȡp_runtskp_schedtskƱˤϡ
     *  ǥѥåԤʤΥåɬפʤΤϡ㳰
     *  롼θƽФɬפʾˡǥѥåɬפʤƤ⡤
     *  reqflgtrueˤ뤿Ǥ롥
     */
    ldr   r0, =p_runtsk       /* p_runtsk r1ɤ߹ */
    ldr   r1, [r0]
    ldr   r0, =dspflg
    ldr   r2, [r0]
    cmp   r2, #0              /* dspflgfalseʤret_int_4 */
    beq   ret_int_4
    ldr   r0, =p_schedtsk     /* p_schedtsk r2ɤ߹ */
    ldr   r2, [r0]
    cmp   r1, r2              /* p_runtskp_schedtskƱʤ */
    beq   ret_int_4           /*                    ret_int_4 */
    stmfd sp!, {r4-r11}       /* ĤΥ쥸¸ */
    str   sp, [r1,#TCB_sp]    /* å¸ */
    adr   r0, ret_int_r       /* ¹ԺƳϤ¸   */
    str   r0, [r1,#TCB_pc]
    b     dispatcher

ALABEL(ret_int_r)
    ldmfd sp!, {r4-r11}       /* 쥸 */    
ALABEL(ret_int_4)
    /*
     *  enatextrueǡtexptn0ǤʤipmflgtrueǤС
     *  㳰롼ƤӽФ
     *  dispatcherƤӽФ뤿ᡤTCBΥɥ쥹r1äƤ
     */
    ldrb  r0, [r1,#TCB_enatex]
    tst   r0, #TCB_enatex_mask
    beq   ret_int_5              /* enatex  false ʤ ret_int5 */
    ldr   r0, [r1,#TCB_texptn]   /* texptn                  */
    tst   r0, r0                 /* texptn 0ʤ ret_int5       */
    beq   ret_int_5
    ldr   r1, =ipmflg           /* ipmflgfalseǤ ret_int5 */
    ldr   r0, [r1]
    tst   r0,r0
    blne  call_texrtn            /* 㳰롼θƤӽФ    */
ALABEL(ret_int_5)
    /*
     *  ߽Υ꥿ˤꡤCPUå֤˰ܹԤ
     *  ˤ롥ARMCPSRIRQӥåȤˤäCPUå֤ɽƤ
     *  뤿ᡤΤޤޥ꥿󤹤Ф褤
     */      
#if (__TARGET_ARCH_ARM == 4) || (__TARGET_ARCH_ARM == 5)
    ldmfd sp!, {r0}             /* spsr  */
    msr   spsr_cxsf,r0          /* cpsrspsr */
    ldmfd sp!,{r0-r3,ip,lr,pc}^ /*  ^դʤΤǡcpsr <- spsr */    
#else /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */
    ldmfd sp!,{r0-r3,ip,lr}
    rfeia sp!
#endif /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */

/*
 * CPU㳰ϥɥ
 *
 * CPU㳰ϥɥϡ󥿥ƥȤǼ¹Ԥ롥
 * 
 */

/*
 *  ̤̿ 㳰ϥɥ
 */
    ATEXT
    AALIGN(2)
    AGLOBAL(undef_handler)
ALABEL(undef_handler)
#if (__TARGET_ARCH_ARM == 4) || (__TARGET_ARCH_ARM == 5)
    /* 
     *  ư⡼(ѡХ⡼)
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET) 
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

    /*
     * spsrϤ뤿̤⡼ɤ
     */
    msr   cpsr_cxsf, #(CPSR_UND AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)
    mov   r0, lr
    mrs   r1, spsr    
#else /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */
    /* 
     * lr() spsr(cpsr_svc)򥹡ѡХ⡼ɤΥå
     * ¸
     */
    srsdb #CPSR_SVC! 

    /* 
     *  㳰ȯư⡼(ѡХ⡼)
     *  ߥå֡CPUå֤CPU㳰ȯ
     *  ֤Ѿ롥
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)    
    stmfd sp!, {r0-r3,ip,lr} 
#endif /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */

    mov   r2, #EXCH_NO_UNDEF
    b     target_exc_handler


/*
 *  SWI 㳰ϥɥ
 */
    ATEXT
    AALIGN(2)
    AGLOBAL(swi_handler)
ALABEL(swi_handler)
#if (__TARGET_ARCH_ARM == 4) || (__TARGET_ARCH_ARM == 5)
    /* 
     *  ư⡼(ѡХ⡼)
     *  ѡХ⡼ɤCPUå֤Ȥ
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET) 
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */
    mov   r0, lr
    mrs   r1, spsr 
#else /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */
    /* 
     * lr() spsr(cpsr_svc)򥹡ѡХ⡼ɤΥå
     * ¸
     */
    srsdb #CPSR_SVC! 

    /* 
     *  㳰ȯư⡼(ѡХ⡼)
     *  ߥå֡CPUå֤CPU㳰ȯ
     *  ֤Ѿ롥
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)    
    stmfd sp!, {r0-r3,ip,lr} 
#endif /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */

    mov   r2, #EXCH_NO_SWI
    b     target_exc_handler


/*
 *  ץեåܡ 㳰ϥɥ
 */
    ATEXT
    AALIGN(2)
    AGLOBAL(prefetch_handler)
ALABEL(prefetch_handler)
#if (__TARGET_ARCH_ARM == 4) || (__TARGET_ARCH_ARM == 5)
    /* 
     *  ư⡼(ѡХ⡼)
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET) 
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

    /*
     * spsrϤ뤿˥ܡȥ⡼ɤ
     */
    msr   cpsr_cxsf, #(CPSR_ABT AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)
    mov   r0, lr
    mrs   r1, spsr
#else /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */
    /* 
     * lr() spsr(cpsr_svc)򥹡ѡХ⡼ɤΥå
     * ¸
     */
    srsdb #CPSR_SVC! 

    /* 
     *  㳰ȯư⡼(ѡХ⡼)
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)    
    stmfd sp!, {r0-r3,ip,lr} 
#endif /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */

    mov   r2, #EXCH_NO_PABORT
    b     target_exc_handler


/*
 *  ǡܡ 㳰ϥɥ
 */
    ATEXT
    AALIGN(2)
    AGLOBAL(data_abort_handler)
ALABEL(data_abort_handler)
#if (__TARGET_ARCH_ARM == 4) || (__TARGET_ARCH_ARM == 5)
    /* 
     *  ư⡼(ѡХ⡼)
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET) 
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

    /*
     * spsrϤ뤿˥ܡȥ⡼ɤ
     */
    msr   cpsr_cxsf, #(CPSR_ABT AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)
    mov   r0, lr
    mrs   r1, spsr    
#else /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */
    /* 
     * lr() spsr(cpsr_svc)򥹡ѡХ⡼ɤΥå
     * ¸
     */
    srsdb #CPSR_SVC! 

    /* 
     *  㳰ȯư⡼(ѡХ⡼)
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)    
    stmfd sp!, {r0-r3,ip,lr} 
#endif /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */

    mov   r2, #EXCH_NO_DABORT
    b     target_exc_handler


#ifndef TARGET_FIQ_HANDLER
/*
 *  FIQ 㳰ϥɥ
 */
    ATEXT
    AALIGN(2)
    AGLOBAL(fiq_handler)
ALABEL(fiq_handler)
#if (__TARGET_ARCH_ARM == 4) || (__TARGET_ARCH_ARM == 5)
    /* 
     *  ư⡼(ѡХ⡼)
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_FIQ_BIT AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET) 
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

    /*
     * spsrϤ뤿FIQ⡼ɤ
     */
    msr   cpsr_cxsf, #(CPSR_FIQ AOR CPSR_FIQ_BIT AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)
    mov   r0, lr
    mrs   r1, spsr 
#else /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */
    /* 
     * lr() spsr(cpsr_svc)򥹡ѡХ⡼ɤΥå
     * ¸
     */
    srsdb #CPSR_SVC! 

    /* 
     *  㳰ȯư⡼(ѡХ⡼)
     */
    msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)    
    stmfd sp!, {r0-r3,ip,lr} 
#endif /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */

    mov   r2, #EXCH_NO_FIQ
    b     target_exc_handler
#endif /* TARGET_FIQ_HANDLER */

/*
 *  Ԥ
 */
    AGLOBAL(_sil_dly_nse)
ALABEL(_sil_dly_nse)
    sub   r0, r0, #SIL_DLY_TIM1
    cmp   r0, #0
    bgt   _sil_dly_nse1
    bxle  lr
ALABEL(_sil_dly_nse1)
    sub   r0, r0, #SIL_DLY_TIM2
    cmp   r0, #0
    bgt   _sil_dly_nse1
    bxle  lr

#ifdef __thumb__
    ATEXT
    AALIGN(2)
    AGLOBAL(current_sr)
ALABEL(current_sr)
    mrs   r0, cpsr
    bx    lr

   AGLOBAL(set_sr)
ALABEL(set_sr)
    msr   cpsr, r0
    bx    lr
#endif /* __thumb__ */
